## labltk 8.06.15

=== Makefile ===
#######################################################################
#                                                                     #
#                 MLTk, Tcl/Tk interface of OCaml                     #
#                                                                     #
#    Francois Rouaix, Francois Pessaux, Jun Furuse and Pierre Weis    #
#               projet Cristal, INRIA Rocquencourt                    #
#            Jacques Garrigue, Kyoto University RIMS                  #
#                                                                     #
#  Copyright 1999 Institut National de Recherche en Informatique et   #
#  en Automatique and Kyoto University.  All rights reserved.         #
#  This file is distributed under the terms of the GNU Library        #
#  General Public License, with the special exception on linking      #
#  described in file LICENSE found in the OCaml source tree.          #
#                                                                     #
#######################################################################

# Top Makefile for mlTk

SUBDIRS=compiler support lib jpf frx examples_labltk \
	examples_camltk browser
SUBDIRS_GENERATED=camltk labltk
WARNERR=-warn-error A-3
include config/Makefile

all-devel:
	$(MAKE) all opt WARNERR="$(WARNERR)"
all: library
	cd browser; $(MAKE)
opt: libraryopt

library:
	cd support; $(MAKE)
	cd compiler; $(MAKE)
	cd labltk; $(MAKE) -f Makefile.gen
	cd labltk; $(MAKE)
	cd camltk; $(MAKE) -f Makefile.gen
	cd camltk; $(MAKE)
	cd lib; $(MAKE)
	cd jpf; $(MAKE)
	cd frx; $(MAKE)

libraryopt:
	cd support; $(MAKE) opt
	cd labltk; $(MAKE) -f Makefile.gen
	cd labltk; $(MAKE) opt
	cd camltk; $(MAKE) -f Makefile.gen
	cd camltk; $(MAKE) opt
	cd lib; $(MAKE) opt
	cd jpf; $(MAKE) opt
	cd frx; $(MAKE) opt

byte: all
opt: allopt

.PHONY: all allopt byte opt apiref library libraryopt
.PHONY: labltk camltk examples examples_labltk examples_camltk
.PHONY: install installopt partialclean clean depend

labltk: Widgets.src
	compiler/tkcompiler -outdir labltk
	cd labltk; $(MAKE)

camltk: Widgets.src
	compiler/tkcompiler -camltk -outdir camltk
	cd camltk; $(MAKE)

examples: examples_labltk examples_camltk

examples_labltk:
	cd examples_labltk; $(MAKE) all

examples_camltk:
	cd examples_camltk; $(MAKE) all

SUPPORTMLIS= fileevent support textvariable timer tkthread widget
apiref:
	$(BINDIR)/ocamldoc -I +threads -I support -I labltk $(SUPPORTMLIS:%=support/%.mli) labltk/*.mli labltk/tk.ml -sort -d htdocs/apiref -html || echo "There were errors"

install:
	cd support; $(MAKE) install
	cd lib; $(MAKE) install
	cd labltk; $(MAKE) install
	cd camltk; $(MAKE) install
	cd compiler; $(MAKE) install
	cd jpf; $(MAKE) install
	cd frx; $(MAKE) install
	cd browser; $(MAKE) install
	if test -f lib/labltk.cmxa; then $(MAKE) installopt; else :; fi

install-browser:
	cd browser; $(MAKE) install

installopt:
	cd support; $(MAKE) installopt
	cd lib; $(MAKE) installopt
	cd labltk; $(MAKE) installopt
	cd camltk; $(MAKE) installopt
	cd jpf; $(MAKE) installopt
	cd frx; $(MAKE) installopt

uninstall:
	ocamlfind remove labltk
	rm -f $(INSTALLBINDIR)/labltk
	rm -f $(INSTALLBINDIR)/ocamlbrowser$(EXE)

reinstall:
	$(MAKE) uninstall
	$(MAKE) install

partialclean clean:
	for d in $(SUBDIRS); do \
	    cd $$d; $(MAKE) -f Makefile clean; cd ..; \
	done
	for d in $(SUBDIRS_GENERATED); do \
	    cd $$d; $(MAKE) -f Makefile.gen clean; cd ..; \
	done

depend:

=== examples_labltk/Makefile ===
#######################################################################
#                                                                     #
#                 MLTk, Tcl/Tk interface of OCaml                     #
#                                                                     #
#    Francois Rouaix, Francois Pessaux, Jun Furuse and Pierre Weis    #
#               projet Cristal, INRIA Rocquencourt                    #
#            Jacques Garrigue, Kyoto University RIMS                  #
#                                                                     #
#  Copyright 2002 Institut National de Recherche en Informatique et   #
#  en Automatique and Kyoto University.  All rights reserved.         #
#  This file is distributed under the terms of the GNU Library        #
#  General Public License, with the special exception on linking      #
#  described in file LICENSE found in the OCaml source tree.          #
#                                                                     #
#######################################################################

include ../support/Makefile.common

COMPFLAGS=-I ../lib -I ../labltk -I ../support -w s -dllpath ../support

all: hello demo eyes calc clock tetris lang

opt: hello.opt demo.opt eyes.opt calc.opt clock.opt tetris.opt

hello: hello.cmo
	$(CAMLC) $(COMPFLAGS) -o hello $(LIBNAME).cma hello.cmo

demo: demo.cmo
	$(CAMLC) $(COMPFLAGS) -o demo $(LIBNAME).cma demo.cmo

eyes: eyes.cmo
	$(CAMLC) $(COMPFLAGS) -o eyes $(LIBNAME).cma eyes.cmo

calc: calc.cmo
	$(CAMLC) $(COMPFLAGS) -o calc $(LIBNAME).cma calc.cmo

clock: clock.cmo
	$(CAMLC) $(COMPFLAGS) -o clock $(LIBNAME).cma \
	  -I +unix unix.cma clock.cmo

clock.opt: clock.cmx
	$(CAMLOPT) $(COMPFLAGS) -o clock.opt \
	      $(LIBNAME).cmxa -I +unix unix.cmxa clock.cmx

tetris: tetris.cmo
	$(CAMLC) $(COMPFLAGS) -o tetris $(LIBNAME).cma tetris.cmo

taquin: taquin.cmo
	$(CAMLC) $(COMPFLAGS) -o taquin $(LIBNAME).cma taquin.cmo

lang: lang.cmo
	$(CAMLC) $(COMPFLAGS) -o lang $(LIBNAME).cma lang.cmo

clean:
	rm -f hello demo eyes calc clock tetris lang *.opt *.o *.cm*

.SUFFIXES :
.SUFFIXES : .mli .ml .cmi .cmx .cmo .opt

.mli.cmi:
	$(CAMLCOMP) $(COMPFLAGS) $<

.ml.cmo:
	$(CAMLCOMP) $(COMPFLAGS) $<

.ml.cmx:
	$(CAMLOPT) -c $(COMPFLAGS) $<

.cmx.opt:
	$(CAMLOPT) $(COMPFLAGS) -o $@ $(LIBNAME).cmxa $<

=== labltk/Makefile ===
#######################################################################
#                                                                     #
#                 MLTk, Tcl/Tk interface of OCaml                     #
#                                                                     #
#    Francois Rouaix, Francois Pessaux, Jun Furuse and Pierre Weis    #
#               projet Cristal, INRIA Rocquencourt                    #
#            Jacques Garrigue, Kyoto University RIMS                  #
#                                                                     #
#  Copyright 2002 Institut National de Recherche en Informatique et   #
#  en Automatique and Kyoto University.  All rights reserved.         #
#  This file is distributed under the terms of the GNU Library        #
#  General Public License, with the special exception on linking      #
#  described in file LICENSE found in the OCaml source tree.          #
#                                                                     #
#######################################################################

include ../support/Makefile.common

COMPFLAGS= -I ../support -no-alias-deps -I +unix

all: labltkobjs

opt: labltkobjsx

include ./modules

LABLTKOBJS = $(WIDGETOBJS) tk.cmo labltk.cmo
LABLTKOBJSX = $(LABLTKOBJS:.cmo=.cmx)

labltkobjs: $(LABLTKOBJS)

labltkobjsx: $(LABLTKOBJSX)

ifeq ($(USE_FINDLIB),yes)
install:
	ocamlfind install labltk -add \
	  $(LABLTKOBJS:.cmo=.cmi) $(WIDGETOBJS:.cmo=.mli)
installopt:
	ocamlfind install labltk -add $(LABLTKOBJSX)
else
install:
	if test -d $(INSTALLDIR); then : ; else mkdir $(INSTALLDIR); fi
	cp $(LABLTKOBJS:.cmo=.cmi) $(WIDGETOBJS:.cmo=.mli) $(INSTALLDIR)
	chmod 644 $(INSTALLDIR)/*.cmi

installopt:
	@if test -d $(INSTALLDIR); then : ; else mkdir $(INSTALLDIR); fi
	cp $(LABLTKOBJSX) $(INSTALLDIR)
	chmod 644 $(INSTALLDIR)/*.cmx
endif

clean:
	$(MAKE) -f Makefile.gen clean

.SUFFIXES :
.SUFFIXES : .mli .ml .cmi .cmx .cmo .mlp

.mli.cmi:
	$(CAMLCOMP) $(COMPFLAGS) $<

.ml.cmo:
	$(CAMLCOMP) $(COMPFLAGS) $<

.ml.cmx:
	$(CAMLOPT) -c $(COMPFLAGS) $<

include .depend

=== lib/Makefile ===
#######################################################################
#                                                                     #
#                 MLTk, Tcl/Tk interface of OCaml                     #
#                                                                     #
#    Francois Rouaix, Francois Pessaux, Jun Furuse and Pierre Weis    #
#               projet Cristal, INRIA Rocquencourt                    #
#            Jacques Garrigue, Kyoto University RIMS                  #
#                                                                     #
#  Copyright 1999 Institut National de Recherche en Informatique et   #
#  en Automatique and Kyoto University.  All rights reserved.         #
#  This file is distributed under the terms of the GNU Library        #
#  General Public License, with the special exception on linking      #
#  described in file LICENSE found in the OCaml source tree.          #
#                                                                     #
#######################################################################

include ../support/Makefile.common

all: $(LIBNAME).cma $(LIBNAME)top$(EXE) $(LIBNAME)

opt: $(LIBNAME).cmxa

clean:
	rm -f $(LIBNAME)top$(EXE) $(LIBNAME) *.cm* *.$(A) *$(EXT_DLL)

superclean:
	- if test -f tk.cmo; then \
	  echo We have changes... Now lib directory has no .cmo files; \
	  rm -f *.cm* *.$(O); \
	fi

include ../labltk/modules
LABLTKOBJS=tk.cmo $(WIDGETOBJS)

include ../camltk/modules
CAMLTKOBJS=cTk.cmo $(CWIDGETOBJS) labltk.cmo camltk.cmo

SUPPORT=../support/support.cmo ../support/rawwidget.cmo \
	../support/widget.cmo ../support/protocol.cmo \
	../support/textvariable.cmo ../support/timer.cmo \
	../support/fileevent.cmo ../support/camltkwrap.cmo

TKOBJS=$(SUPPORT) $(LABLTKOBJS) $(CAMLTKOBJS)

TOPLEVELLIBS=ocamlcommon.cma ocamlbytecomp.cma ocamltoplevel.cma

TOPLEVELSTART=topstart.cmo

TOPDEPS = $(TOPLEVELLIBS) $(TOPLEVELSTART)

$(LIBNAME).cma: $(SUPPORT) ../Widgets.src
	$(MAKE) superclean
	cd ../labltk; $(MAKE)
	cd ../camltk; $(MAKE)
	$(MKLIB) -ocamlc '$(CAMLCB)' -o $(LIBNAME) \
	  -I ../labltk -I ../camltk $(TKOBJS) \
	  -cclib "\"$(TK_LINK)\""

$(LIBNAME).cmxa: $(SUPPORT:.cmo=.cmx) ../Widgets.src
	$(MAKE) superclean
	cd ../labltk; $(MAKE) opt
	cd ../camltk; $(MAKE) opt
	$(MKLIB) -ocamlopt '$(CAMLOPTB)' -o $(LIBNAME) -oc $(LIBNAME) \
	  -I ../labltk -I ../camltk $(TKOBJS:.cmo=.cmx) \
	  -cclib "\"$(TK_LINK)\""

$(LIBNAME)top$(EXE) : $(LIBNAME).cma ../support/lib$(LIBNAME).$(A)
	$(CAMLC) -verbose -linkall -o $(LIBNAME)top$(EXE) -I ../support \
	       $(TOPLEVELLIBS) \
	       -I +compiler-libs -I +unix -I +str unix.cma str.cma \
	       -I ../labltk -I ../camltk $(LIBNAME).cma \
	       $(TOPLEVELSTART)

$(LIBNAME): Makefile
	@echo Generate $@
	@echo "#!/bin/sh" > $@
	@echo 'exec $(INSTALLDIR)/$(LIBNAME)top$(EXE) -I $(INSTALLDIR) "$$@"' >> $@

install-script: $(LIBNAME)
	cp $(LIBNAME) $(INSTALLBINDIR)
	chmod 755 $(INSTALLBINDIR)/$(LIBNAME)

install-batch:
	cp labltk.bat $(INSTALLBINDIR)

ifeq ($USE_FINDLIB,yes)
install:
	ocamlfind install labltk -add  $(LIBNAME).cma $(LIBNAME)top$(EXE)
	chmod 755 $(INSTALLDIR)/$(LIBNAME)top$(EXE)
	@case x$(TOOLCHAIN) in \
	  xmingw|xmsvc) $(MAKE) install-batch ;; \
	  *) 		$(MAKE) install-script ;; \
	esac

installopt:
	ocamlfind install labltk -add $(LIBNAME).cmxa $(LIBNAME).$(A)
	cd $(INSTALLDIR); $(RANLIB) $(LIBNAME).$(A)
else
install:
	if test -d $(INSTALLDIR); then : ; else mkdir $(INSTALLDIR); fi
	cp $(LIBNAME).cma $(LIBNAME)top$(EXE) $(INSTALLDIR)
	chmod 644 $(INSTALLDIR)/$(LIBNAME).cma
	chmod 755 $(INSTALLDIR)/$(LIBNAME)top$(EXE)
	@if test -d $(INSTALLBINDIR); then : ; else mkdir $(INSTALLBINDIR); fi
	@case x$(TOOLCHAIN) in \
	  xmingw|xmsvc) $(MAKE) install-batch ;; \
	  *) 		$(MAKE) install-script ;; \
	esac

installopt:
	@if test -d $(INSTALLDIR); then : ; else mkdir $(INSTALLDIR); fi
	cp $(LIBNAME).cmxa $(LIBNAME).$(A) $(INSTALLDIR)
	cd $(INSTALLDIR); $(RANLIB) $(LIBNAME).$(A)
	chmod 644 $(INSTALLDIR)/$(LIBNAME).cmxa
	chmod 644 $(INSTALLDIR)/$(LIBNAME).$(A)
endif

=== debian/changelog ===
labltk (8.06.15-1build1) questing; urgency=medium

  * Rebuild against new OCAML ABIs.

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Mon, 16 Jun 2025 14:54:26 +0200

labltk (8.06.15-1) unstable; urgency=medium

  * New upstream release

 -- Stéphane Glondu <glondu@debian.org>  Tue, 11 Feb 2025 17:04:44 +0100

=== debian/control ===
Source: labltk
Section: ocaml
Priority: optional
Maintainer: Debian OCaml Maintainers <debian-ocaml-maint@lists.debian.org>
Uploaders:
 Stéphane Glondu <glondu@debian.org>
Build-Depends:
 debhelper-compat (= 13),
 ocaml,
 ocaml-findlib,
 tk-dev,
 dh-ocaml
Standards-Version: 4.7.0
Rules-Requires-Root: no
Homepage: https://github.com/garrigue/labltk
Vcs-Browser: https://salsa.debian.org/ocaml-team/labltk
Vcs-Git: https://salsa.debian.org/ocaml-team/labltk.git

Package: labltk
Architecture: any
Depends:
 liblabltk-ocaml-dev,
 ${shlibs:Depends},
 ${misc:Depends},
 ${ocaml:Depends}
Provides:
 ${ocaml:Provides}
Recommends: ocaml-findlib
Description: OCaml bindings to Tcl/Tk (executables)
 mlTk is a library for interfacing OCaml with the scripting language
 Tcl/Tk.
 .
 In addition to the basic interface with Tcl/Tk, this package contains
 the OCamlBrowser code editor / library browser written by Jacques
 Garrigue.

Package: liblabltk-ocaml-dev
Architecture: any
Depends:
 ${shlibs:Depends},
 ${misc:Depends},
 ${ocaml:Depends}
Provides:
 ${ocaml:Provides}
Recommends: ocaml-findlib
Description: OCaml bindings to Tcl/Tk (dev. libraries)
 mlTk is a library for interfacing OCaml with the scripting language
 Tcl/Tk.
 .
 In addition to the basic interface with Tcl/Tk, this package contains
  * the "jpf" library, written by Jun P. Furuse; it contains a "file
    selector" and "balloon help" support;
  * the "frx" library, written by Francois Rouaix;
  * the "tkanim" library, which supports animated gif loading/display.
 .
 This package contains development libraries.

Package: liblabltk-ocaml
Architecture: any
Depends:
 ${shlibs:Depends},
 ${misc:Depends},
 ${ocaml:Depends}
Provides:
 ${ocaml:Provides}
Recommends: ocaml-findlib
Description: OCaml bindings to Tcl/Tk (runtime libraries)
 mlTk is a library for interfacing OCaml with the scripting language
 Tcl/Tk.
 .
 In addition to the basic interface with Tcl/Tk, this package contains
  * the "jpf" library, written by Jun P. Furuse; it contains a "file
    selector" and "balloon help" support;
  * the "frx" library, written by Francois Rouaix;
  * the "tkanim" library, which supports animated gif loading/display.
 .
 This package contains runtime libraries.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

DESTDIR=$(CURDIR)/debian/tmp
include /usr/share/ocaml/ocamlvars.mk

OCAMLFIND_DESTDIR=$(DESTDIR)/$(OCAML_STDLIB_DIR)
export OCAMLFIND_DESTDIR

CONFIGURE_OPTS := -use-findlib -installbindir $(DESTDIR)/usr/bin

%:
	dh $@ --with ocaml

override_dh_auto_configure:
	./configure $(CONFIGURE_OPTS)

override_dh_auto_build:
	$(MAKE) library
ifeq ($(OCAML_HAVE_OCAMLOPT),yes)
	$(MAKE) libraryopt
endif

override_dh_auto_install:
	mkdir -p $(OCAMLFIND_DESTDIR) $(OCAMLFIND_DESTDIR)/stublibs $(DESTDIR)/usr/bin
	dh_auto_install

override_dh_auto_clean:
	./configure $(CONFIGURE_OPTS)
	dh_auto_clean
	rm -f config/Makefile config/auto-aux/tst config/auto-aux/hasgot.c

override_dh_missing:
	dh_missing --fail-missing -X.so.owner

override_dh_dwz:
